{% extends "./plantilla.html" %}
{% load static %}
{% block contenido %}
    <div class="container">
        <div class="row">
            <div class="col-md-6">
                <h1 class="text-center blanco-text">Nueva Carrera</h1>
                <form class="mb-4" action="/guardarCarrera/" method="post" enctype="multipart/form-data" id="frm_nueva_car">
                    {% csrf_token %}
                    <div class="mb-3">
                        <label for="nombreCarreraBAFA" class="form-label blanco-text">Nombre de la Carrera:</label>
                        <input type="text" name="nombreCarreraBAFA" id="nombreCarreraBAFA" value="" class="form-control" placeholder="Ingrese el nombre de la carrera:" required>
                    </div>
                    <div class="mb-3">
                        <label for="directorCarreraBAFA" class="form-label blanco-text">Director de la Carrera:</label>
                        <input type="text" name="directorCarreraBAFA" id="directorCarreraBAFA" value="" class="form-control" placeholder="Ingrese el director de la carrera:" required>
                    </div>
                    <div class="mb-3">
                        <label for="logoCarreraBAFA" class="form-label blanco-text">Logo de la Carrera:</label>
                        <input type="file" accept="image/*" name="logoCarreraBAFA" id="logoCarreraBAFA" value="" class="form-control" placeholder="Ingrese el logotipo:" required>
                    </div>
                    <div class="mb-3">
                        <label for="duracionCarreraBAFA" class="form-label blanco-text"><b>Duraacion de la Carrera:</b></label>
                        <input type="number" name="duracionCarreraBAFA" id="duracionCarreraBAFA" value="" class="form-control" placeholder="Ingrese la Duracion de la carrera:" required>
                    </div>
                    <div class="mb-3">
                        <label for="requisitosIngresoBAFA" class="form-label blanco-text">Ingrese los Requisitos de la Carrera:</label>
                        <textarea name="requisitosIngresoBAFA" id="requisitosIngresoBAFA" cols="3" class="form-control" placeholder="Ingrese los requisitos:" required></textarea>
                    </div>
                    <div class="text-center">
                        <button type="submit" name="button" class="btn btn-primary">Guardar</button>
                        <button type="reset" name="button" class="btn btn-danger">Cancelar</button>
                        <button id="toggleChartButton" onclick="toggleChart()" class="btn btn-info">Mostrar/ocultar gráfico</button>
                    </div>
                </form>
            </div>
            <div class="col-md-6">
                <h1 class="text-center blanco-text">LISTADO DE LAS CARRERAS</h1>
                <table class="table" id="tbl_carre">
                    <thead>
                        <tr>
                            <th>ID</th>
                            <th>NOMBRE</th>
                            <th>DIRECTOR</th>
                            <th>LOGOTIPO</th>
                            <th>DURACION</th>
                            <th>REQUISITOS</th>
                            <th>ACCIONES</th>
                        </tr>
                    </thead>
                    <TBody>
                        {% for carrera in carreras %}
                            <tr>
                                <td>{{ carrera.idCarreraBAFA }}</td>
                                <td>{{ carrera.nombreCarreraBAFA }}</td>
                                <td>{{ carrera.directorCarreraBAFA }}</td>
                                <td>
                                    {% if carrera.logoCarreraBAFA %}
                                    <a href="{{ carrera.logoCarreraBAFA.url }}" target="_blank"><img src="{{ carrera.logoCarreraBAFA.url }}" alt="" height="80px"></a>
                                    {% else %}
                                    <b>N/A</b>
                                    {% endif %}
                                </td>
                                <td>{{ carrera.duracionCarreraBAFA }}</td>
                                <td>{{ carrera.requisitosIngresoBAFA }}</td>
                                <td>
                                    <a href="/editarCarrera/{{ carrera.idCarreraBAFA }}" class="btn btn-warning">Editar</a>
                                    <a href="javascript:void(0)" class="btn btn-danger" onclick="eliminarCarrera('/eliminarCarrera/{{ carrera.idCarreraBAFA }}');">Borrar</a>

                                </td>
                            </tr>
                        {% endfor %}
                    </TBody>
                </table>
            </div>
        </div>
    </div>

    <script type="text/javascript">
        function eliminarCarrera(url) {
            iziToast.question({
                timeout: 15000,
                close: true,
                overlay: true,
                displayMode: 'once',
                id: 'question',
                zindex: 999,
                title: 'CONFIRMACIÓN',
                message: '¿Está seguro de eliminar la Carrera Selecionada?',
                position: 'center',
                buttons: [
                    ['<button><b>SI</b></button>', function (instance, toast) {
                        instance.hide({ transitionOut: 'fadeOut' }, toast, 'button');
                        window.location.href = url;
                    }, true],
                    ['<button>NO</button>', function (instance, toast) {
                        instance.hide({ transitionOut: 'fadeOut' }, toast, 'button');
                    }],
                ]
            });
        }
    </script>

    <script type="text/javascript">
        $("#frm_nueva_car").validate({
            rules:{
                "nombreCarreraBAFA":{
                    required: true
                },
                "directorCarreraBAFA":{
                    required: true
                },
                "logoCarreraBAFA":{
                    required: true
                },
                "duracionCarreraBAFA":{
                    required: true
                },
                "requisitosIngresoBAFA":{
                    required: true
                }
            },
            messages:{
                "nombreCarreraBAFA":{
                    required: "Por favor Ingrese un Nombre valido"
                },
                "directorCarreraBAFA":{
                    required: "Debe ingresar un Director valido"
                },
                "logoCarreraBAFA":{
                    required: "Debe ingresar el logo de la carrera"
                },
                "duracionCarreraBAFA":{
                    required: "Debe ingresar una duracion valida"
                },
                "requisitosIngresoBAFA":{
                    required: "Debe ingresar los requisitos de la carrera"
                },
            }
        });
    </script>

    <script type="text/javascript">
           //let table = new DataTable('#tbl_clientes');
           $(document).ready(function() {
               $('#tbl_carre').DataTable({
                   dom: 'Bfrtip',
                   language: {
                     url: '//cdn.datatables.net/plug-ins/1.13.7/i18n/es-ES.json',
                   },
                   buttons: [
                       {
                           extend: 'pdfHtml5',
                           text: '<i class="fa fa-file-pdf-o"></i> PDF',
                           titleAttr: 'Exportar a PDF',
                           className: 'btn btn-danger', // Clase de estilo para el botón
                           title: 'LISTADO CARRERAS'
                       },
                       {
                           extend: 'print',
                           text: '<i class="fa fa-print"></i> Imprimir',
                           titleAttr: 'Imprimir',
                           className: 'btn btn-primary' // Clase de estilo para el botón
                       },
                       {
                           extend: 'csv',
                           text: '<i class="fa fa-file-text-o"></i> CSV',
                           titleAttr: 'Exportar a CSV',
                           className: 'btn btn-success' // Clase de estilo para el botón
                       }
                   ]
               });
           });

          </script>
          <script>
                  $(document).ready(function () {
                      $("#logoCarreraBAFA").fileinput({
                        //showUpload:false
                        //showRemove: false,
                        language:'es',
                      });
                  });
          </script>

                <div id="chartContainer" style="width: 50%; margin: auto; border: 2px solid black; padding: 10px; display: none;">
                  <canvas id="myChart"></canvas>
                </div>

                <script>
                    document.addEventListener('DOMContentLoaded', function () {
                      const ctx = document.getElementById('myChart');

                      const carreraSet = new Set();

                      const carreraMod = {};
                      {% for carrera in carreras %}
                        carreraSet.add("{{ carrera.duracionCarreraBAFA }}");
                        if (!carreraMod["{{ carrera.duracionCarreraBAFA }}"]) {
                          carreraMod["{{ carrera.duracionCarreraBAFA }}"] = 1;
                        } else {
                          carreraMod["{{ carrera.duracionCarreraBAFA }}"] += 1;
                        }
                      {% endfor %}
                      const carreraArray = Array.from(carreraSet);
                      const posiciones = carreraArray.map((carrera, index) => ({ x: index, y: carreraMod[carrera] || 0 }));

                      new Chart(ctx, {
                        type: 'bar',
                        data: {
                          labels: carreraArray,
                          datasets: [{
                            label: 'Modalidad',
                            data: posiciones.map(posicion => posicion.y),
                            backgroundColor: 'rgba(623, 235, 192)',
                            borderColor: 'rgba(248, 192, 192)',
                            borderWidth: 1,
                          }]
                        },
                        options: {
                          scales: {
                            x: {
                              type: 'category',
                              position: 'bottom',
                            },
                            y: {
                              beginAtZero: true,
                              max: 10,
                              stepSize: 1,
                            }
                          }
                        }
                      });
                      window.toggleChart = function() {
                        const chartContainer = document.getElementById('chartContainer');

                        if (chartContainer.style.display === 'none') {
                          chartContainer.style.display = 'block';
                        } else {
                          chartContainer.style.display = 'none';
                        }
                      };
                    });

                </script>
{% endblock %}
